package com.ims.eval.service.impl;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptRatingMapper;
import com.ims.eval.entity.EvaluationDeptBusinessPlan;
import com.ims.eval.entity.EvaluationDeptRating;
import com.ims.eval.service.IEvaluationDeptRatingService;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author hlf
 * @date 2023/4/28 16:16
 * 文件说明：
 */
@Service
public class EvaluationDeptRatingServiceImpl extends ServiceImpl<EvaluationDeptRatingMapper, EvaluationDeptRating> implements IEvaluationDeptRatingService {

	@Override
	public IPage<EvaluationDeptRating> listPage(Integer pageNum, Integer pageSize, String deptName, String annual) {
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationDeptRating> page = new Page<>(pageNum, pageSize);
		return baseMapper.selectListPage(page, deptName, annual);
	}

	@Override
	public boolean saveOrUpdate(EvaluationDeptRating evaluationDeptRating) {
		if (StringUtils.isEmpty(evaluationDeptRating.getId())){
			QueryWrapper<EvaluationDeptRating> qw = new QueryWrapper<>();
			if (StringUtils.isNotEmpty(evaluationDeptRating.getDeptId())) {
				qw.lambda().eq(EvaluationDeptRating::getDeptId, evaluationDeptRating.getDeptId());
			}
			if (StringUtils.isNotEmpty(evaluationDeptRating.getAnnual())) {
				qw.lambda().eq(EvaluationDeptRating::getAnnual, evaluationDeptRating.getAnnual());
			}
			EvaluationDeptRating deptRating = baseMapper.selectOne(qw);
			if (ObjectUtil.isNotNull(deptRating)){
				return false;
			}
		}
		int count = 0;
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJan()) && "A".equals(evaluationDeptRating.getJan())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getFeb()) && "A".equals(evaluationDeptRating.getFeb())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMar()) && "A".equals(evaluationDeptRating.getMar())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getApr()) && "A".equals(evaluationDeptRating.getApr())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getMay()) && "A".equals(evaluationDeptRating.getMay())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJun()) && "A".equals(evaluationDeptRating.getJun())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getJul()) && "A".equals(evaluationDeptRating.getJul())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getAug()) && "A".equals(evaluationDeptRating.getAug())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getSep()) && "A".equals(evaluationDeptRating.getSep())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getOct()) && "A".equals(evaluationDeptRating.getOct())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getNov()) && "A".equals(evaluationDeptRating.getNov())){
			count += 1;
		}
		if (StringUtils.isNotEmpty(evaluationDeptRating.getDece()) && "A".equals(evaluationDeptRating.getDece())){
			count += 1;
		}
		evaluationDeptRating.setAcount(Convert.toStr(count));
		return super.saveOrUpdate(evaluationDeptRating);
	}
}
